import { ElementRef, OnDestroy } from '@angular/core';
import { Observable } from 'rxjs';
export declare abstract class BaseComponent implements OnDestroy {
    layoutContainerNode: any;
    shadowedAttributes: any;
    private _subscriptions;
    protected makeFullHeight(el: ElementRef): void;
    protected on(observable: Observable<any>, next: (value: any) => void): void;
    protected onMany(observables: Observable<any>[], next: (value: any) => void): void;
    ngOnDestroy(): void;
}
