import { EventEmitter, OnChanges, OnDestroy, SimpleChanges, ViewContainerRef, ChangeDetectorRef } from '@angular/core';
import { ExtendedFormGroup } from '../../forms/extended-form-group';
import { ComponentCreatorService } from '../../services/component-creator.service';
export declare class DynamicComponent implements OnChanges, OnDestroy {
    private _componentCreator;
    private _cdr;
    mainContainer: ViewContainerRef;
    schema: any;
    form?: ExtendedFormGroup;
    defaultFormValues: any;
    eventListeners: {
        [eventName: string]: any;
    };
    onFormsReady: EventEmitter<{}>;
    onEvent: EventEmitter<{}>;
    _forms: ExtendedFormGroup[];
    private _subcribers;
    constructor(_componentCreator: ComponentCreatorService, _cdr: ChangeDetectorRef);
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    private _removeAllSubscriptions;
    private _reload;
}
