var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, EventEmitter, Input, Output, } from '@angular/core';
var EntitySelectorDialog = /** @class */ (function () {
    function EntitySelectorDialog() {
        this.entityMultiSelect = true;
        this.onSubmit = new EventEmitter();
        this.onClose = new EventEmitter();
    }
    EntitySelectorDialog.prototype.ngOnInit = function () {
        var _this = this;
        this.eventListeners = {
            onSubmit: function (event) { return _this.onSubmit.emit(event); },
            onClose: function (event) { return _this.onClose.emit(event); },
        };
        this.schema = {
            component: 'EntitySelectorDialog',
            attributes: {
                entityType: this.entityType,
                entityMultiSelect: this.entityMultiSelect,
            }
        };
    };
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], EntitySelectorDialog.prototype, "entityType", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], EntitySelectorDialog.prototype, "entityMultiSelect", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], EntitySelectorDialog.prototype, "onSubmit", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], EntitySelectorDialog.prototype, "onClose", void 0);
    EntitySelectorDialog = __decorate([
        Component({
            selector: 'entity-selector-dialog',
            template: "\n      <dynamic-component [schema]=\"schema\" [eventListeners]=\"eventListeners\"></dynamic-component>\n    ",
        })
    ], EntitySelectorDialog);
    return EntitySelectorDialog;
}());
export { EntitySelectorDialog };
//# sourceMappingURL=entity-selector-dialog.component.js.map