import { ChangeDetectorRef, OnInit } from '@angular/core';
import { NgRedux } from '@angular-redux/store';
import { TranslateService } from '@ngx-translate/core';
import { IAppState } from '../../redux/stores';
import { FormFieldActions } from '../../redux/actions';
import { BaseFieldEditor } from '../base-field-editor/base-field-editor.component';
import { SortableList } from '../sortable-list/sortable-list.component';
export declare class FieldEditorFieldSelector extends BaseFieldEditor implements OnInit {
    private _ngRedux;
    private _formFieldActions;
    protected _changeDetection: ChangeDetectorRef;
    private _translate;
    protected _fields: any[];
    showSortDialog: boolean;
    sortable: boolean;
    sortableList: SortableList;
    areaName: string;
    idSelector: (field: any) => any;
    constructor(_ngRedux: NgRedux<IAppState>, _formFieldActions: FormFieldActions, _changeDetection: ChangeDetectorRef, _translate: TranslateService);
    items: any[];
    viewItems: any[];
    readonly visibleIds: any;
    protected fieldsSelector(state: IAppState): any[];
    ngOnInit(): void;
    readonly titlePreviewSelector: (field: any) => any;
    readonly titleEditSelector: (field: any) => any;
    remove(field: any): void;
    removeAll(): void;
    onFieldSelect(field: any, checked: boolean): void;
    toIdArray(fields: any[]): any[];
    toFieldArray(ids: string[]): any[];
    displaySortDialog(): void;
    saveAndClose(): void;
    closeWithoutSaving: () => Promise<void>;
    canDeactivate(): boolean;
    confirmDeactivate(): Promise<boolean>;
    readonly fields: any[];
    readonly viewFields: any[];
    private _updateValue;
}
