var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { Component, ChangeDetectorRef, ChangeDetectionStrategy, Input, ViewChild } from '@angular/core';
import isEqual from 'lodash-es/isEqual';
import cloneDeep from 'lodash-es/cloneDeep';
import { NgRedux } from '@angular-redux/store';
import { TranslateService } from '@ngx-translate/core';
import { skip, take } from 'rxjs/operators';
import { FormFieldActions } from '../../redux/actions';
import { BaseFieldEditor } from '../base-field-editor/base-field-editor.component';
import { SortableList } from '../sortable-list/sortable-list.component';
var FieldEditorFieldSelector = /** @class */ (function (_super) {
    __extends(FieldEditorFieldSelector, _super);
    function FieldEditorFieldSelector(_ngRedux, _formFieldActions, _changeDetection, _translate) {
        var _this = _super.call(this, _changeDetection) || this;
        _this._ngRedux = _ngRedux;
        _this._formFieldActions = _formFieldActions;
        _this._changeDetection = _changeDetection;
        _this._translate = _translate;
        _this.showSortDialog = false;
        _this.sortable = true;
        _this.idSelector = function (field) { return field.id; };
        _this.closeWithoutSaving = function () { return __awaiter(_this, void 0, void 0, function () {
            var canDeactivate, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.canDeactivate();
                        if (_a) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.confirmDeactivate()];
                    case 1:
                        _a = (_b.sent());
                        _b.label = 2;
                    case 2:
                        canDeactivate = _a;
                        if (!canDeactivate) {
                            return [2 /*return*/];
                        }
                        this.showSortDialog = false;
                        return [2 /*return*/];
                }
            });
        }); };
        return _this;
    }
    Object.defineProperty(FieldEditorFieldSelector.prototype, "items", {
        get: function () {
            return this.getValue(this.editLanguage);
        },
        set: function (value) {
            if (this.valueAsDictionary) {
                this.value[this.editLanguage] = value;
            }
            else {
                this.value = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FieldEditorFieldSelector.prototype, "viewItems", {
        get: function () {
            return this.items;
        },
        set: function (value) {
            this.items = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FieldEditorFieldSelector.prototype, "visibleIds", {
        get: function () {
            return null;
        },
        enumerable: true,
        configurable: true
    });
    FieldEditorFieldSelector.prototype.fieldsSelector = function (state) {
        return state.settings.field.entities;
    };
    FieldEditorFieldSelector.prototype.ngOnInit = function () {
        var _this = this;
        this.on(this._ngRedux.select(function (state) { return _this.fieldsSelector(state); }), function (fields) {
            _this._fields = fields;
            _this._changeDetection.markForCheck();
        });
        _super.prototype.ngOnInit.call(this);
    };
    Object.defineProperty(FieldEditorFieldSelector.prototype, "titlePreviewSelector", {
        get: function () {
            return function (field) { return field.title; };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FieldEditorFieldSelector.prototype, "titleEditSelector", {
        get: function () {
            return function (field) { return field.title; };
        },
        enumerable: true,
        configurable: true
    });
    FieldEditorFieldSelector.prototype.remove = function (field) {
        var _this = this;
        if (!field) {
            return;
        }
        var value = this.fields;
        var index = value.findIndex(function (f) { return _this.idSelector(f) === _this.idSelector(field); });
        if (index === -1) {
            return;
        }
        this._updateValue(value.slice(0, index).concat(value.slice(index + 1, value.length)));
    };
    FieldEditorFieldSelector.prototype.removeAll = function () {
        this._updateValue([]);
    };
    FieldEditorFieldSelector.prototype.onFieldSelect = function (field, checked) {
        if (!checked) {
            this.remove(field);
            return;
        }
        this._updateValue(this.fields.concat(field));
    };
    FieldEditorFieldSelector.prototype.toIdArray = function (fields) {
        var _this = this;
        return fields.map(function (f) { return _this.idSelector(f); });
    };
    FieldEditorFieldSelector.prototype.toFieldArray = function (ids) {
        var _this = this;
        return ids.map(function (id) {
            var field = _this._fields.find(function (f) { return _this.idSelector(f) === id; });
            return field || { id: id, title: id };
        });
    };
    FieldEditorFieldSelector.prototype.displaySortDialog = function () {
        var _this = this;
        this.showSortDialog = true;
        setTimeout(function () { return _this.sortableList.items = _this.fields; }, 0);
    };
    FieldEditorFieldSelector.prototype.saveAndClose = function () {
        this._updateValue(this.sortableList.items);
        this.showSortDialog = false;
    };
    FieldEditorFieldSelector.prototype.canDeactivate = function () {
        return isEqual(this.fields, this.sortableList.items);
    };
    FieldEditorFieldSelector.prototype.confirmDeactivate = function () {
        this._formFieldActions.showPendingChangesConfirmDispatch(true);
        // we skip 1, and take first value, in order to make the promise pending,
        // and it will be resolved when user select cancel or OK on confirmation dialog.
        return this._ngRedux.select(function (state) { return state.formField.losePendingChangeConfirm; }).pipe(skip(1), take(1)).toPromise();
    };
    Object.defineProperty(FieldEditorFieldSelector.prototype, "fields", {
        get: function () {
            return this.toFieldArray(this.items || []);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FieldEditorFieldSelector.prototype, "viewFields", {
        get: function () {
            return this.toFieldArray(this.viewItems || []);
        },
        enumerable: true,
        configurable: true
    });
    FieldEditorFieldSelector.prototype._updateValue = function (items) {
        this.items = this.toIdArray(items);
        this.valueChange(cloneDeep(this.getValue(this.editLanguage)), this.editLanguage);
    };
    __decorate([
        ViewChild('sortableList'),
        __metadata("design:type", SortableList)
    ], FieldEditorFieldSelector.prototype, "sortableList", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], FieldEditorFieldSelector.prototype, "areaName", void 0);
    FieldEditorFieldSelector = __decorate([
        Component({
            selector: 'field-editor-field-selector',
            template: "\n      <field-editor [field]=\"field\">\n          <div preview>\n              <tags *ngIf=\"viewItems?.length\" [value]=\"viewFields\" [titleSelector]=\"titlePreviewSelector\" [readonly]=\"true\"></tags>\n          </div>\n          <div edit>\n              <field-selector #control [areaName]=\"areaName\" (onFieldSelect)=\"onFieldSelect($event.option, $event.checked)\" [value]=\"fields\" [visibleIds]=\"visibleIds\"></field-selector>\n              <a class=\"base__fake__link\" (click)=\"removeAll()\">{{ 'setting.fieldSelector.removeAll' | translate }}</a>&nbsp;\n              <a *ngIf=\"sortable\" class=\"base__fake__link\" (click)=\"displaySortDialog()\">{{ 'setting.fieldSelector.sort' | translate }}</a>\n              <div *ngIf=\"items?.length\">\n                  <tags [value]=\"fields\" [titleSelector]=\"titleEditSelector\" (onTagRemove)=\"remove($event)\"></tags>\n              </div>\n          </div>\n      </field-editor>\n\n      <base-dialog \n          *ngIf=\"showSortDialog\"\n          [close]=\"closeWithoutSaving\"\n          [minHeight]=\"260\"\n          [cssClass]=\"'modal-dialog-with-list'\">\n          <div title>\n              {{ 'dialog.sortDialog.fields.title' | translate }}\n          </div>\n          <div body class=\"base__height__full\">\n              <sortable-list [itemIdKey]=\"'id'\" #sortableList></sortable-list>\n          </div>\n          <div footer>\n              <button type=\"button\" class=\"base__default\" (click)=\"closeWithoutSaving()\">{{'general.action.cancel' | translate}}</button>\n              <button type=\"button\" class=\"base__success\" (click)=\"saveAndClose()\">{{'general.action.ok' | translate}}</button>\n          </div>\n      </base-dialog>\n    ",
            changeDetection: ChangeDetectionStrategy.OnPush,
        }),
        __metadata("design:paramtypes", [NgRedux,
            FormFieldActions,
            ChangeDetectorRef,
            TranslateService])
    ], FieldEditorFieldSelector);
    return FieldEditorFieldSelector;
}(BaseFieldEditor));
export { FieldEditorFieldSelector };
//# sourceMappingURL=field-editor-field-selector.component.js.map