var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ChangeDetectionStrategy, Input } from '@angular/core';
import { SingleSelect } from '../single-select/single-select.component';
var nextId = 0;
var MultiSelect = /** @class */ (function (_super) {
    __extends(MultiSelect, _super);
    function MultiSelect() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.isChecked = function (option) { };
        _this.inputId = "multi-select-" + nextId++ + "-";
        _this.isMultiSelect = true;
        return _this;
    }
    MultiSelect.prototype.getNumOfChecked = function () {
        var _this = this;
        return this.options.filter(function (option) { return _this.isChecked(option); }).length;
    };
    __decorate([
        Input(),
        __metadata("design:type", Function)
    ], MultiSelect.prototype, "isChecked", void 0);
    MultiSelect = __decorate([
        Component({
            selector: 'multi-select',
            template: "\n      <dropdown [label]=\"label\" [borderless]=\"borderless\" [isExpand]=\"isOpen\" (onExpand)=\"onExpand($event)\" [disabled]=\"disabled\">\n          <div class=\"base__height__full\">\n              <div *ngIf=\"filerable\" class=\"filter\">\n                  <input #filterInput [(ngModel)]=\"filterText\" placeholder=\"{{ 'general.action.search' | translate }}\" />\n                  <i class=\"fa fa-search\"></i>\n              </div>\n              <ul>\n                  <ng-content></ng-content>\n                  <li *ngFor=\"let option of options | filter:textSelector:filterText; let i = index\" class=\"dropdown__list__item\" [class.readonly]=\"option.isGroup\">\n                      <b *ngIf=\"option.isGroup\" class=\"group\">{{textSelector(option) | translate}}</b>\n                      <ng-container *ngIf=\"!option.isGroup\">\n                          <ng-container *ngIf=\"isMultiSelect\">\n                              <input type=\"checkbox\" class=\"form__checkbox\" [id]=\"inputId + idSelector(option)\" [checked]=\"isChecked(option)\" \n                                  (change)=\"onOptionChange.emit({ option: option, checked: $event.target.checked})\" [disabled]=\"acceptNoneValue ? false: isChecked(option) && getNumOfChecked() === 1\">\n                              <label [for]=\"inputId + idSelector(option)\" class=\"base__width__full\">{{textSelector(option)}}</label>\n                          </ng-container>\n                          <ng-container *ngIf=\"!isMultiSelect\">\n                              <label [for]=\"inputId + idSelector(option)\" class=\"base__width__full\" \n                                  (click)=\"onOptionChange.emit({ option: option});isOpen = false\">{{textSelector(option)}}</label>\n                          </ng-container>\n                      </ng-container>\n                  </li>\n              </ul>\n              <div class=\"dropdown__accept__button\" *ngIf=\"isMultiSelect\">\n                  <button (click)=\"isOpen = false\">{{ 'general.action.ok' | translate }}</button>\n              </div>\n          </div>\n      </dropdown>\n    ",
            changeDetection: ChangeDetectionStrategy.OnPush,
        })
    ], MultiSelect);
    return MultiSelect;
}(SingleSelect));
export { MultiSelect };
//# sourceMappingURL=multi-select.component.js.map