var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ChangeDetectionStrategy, EventEmitter, Input, Output } from '@angular/core';
var Tags = /** @class */ (function () {
    function Tags() {
        this.readonly = false;
        this.titleSelector = function (tag) { return String; };
        this.onTagRemove = new EventEmitter();
    }
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], Tags.prototype, "value", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], Tags.prototype, "readonly", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Function)
    ], Tags.prototype, "titleSelector", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], Tags.prototype, "onTagRemove", void 0);
    Tags = __decorate([
        Component({
            selector: 'tags',
            template: "\n      <div class=\"ui__tags\" *ngIf=\"value\">\n          <ul>\n              <li class=\"base__cursor\" *ngFor=\"let tag of value; let i = index\">\n                  <span>{{ titleSelector(tag) }}</span>\n                  <i *ngIf=\"!readonly\" (click)=\"onTagRemove.emit(tag)\" class=\"fa fa-close base__cursor__pointer\"></i>\n              </li>\n          </ul>\n      </div>\n    ",
            changeDetection: ChangeDetectionStrategy.OnPush,
        })
    ], Tags);
    return Tags;
}());
export { Tags };
//# sourceMappingURL=tags.component.js.map