var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Directive, ElementRef, Input } from '@angular/core';
var DisableInputDirective = /** @class */ (function () {
    function DisableInputDirective(_element) {
        this._element = _element;
    }
    DisableInputDirective.prototype.ngOnInit = function () {
        var _this = this;
        window.setTimeout(function () {
            _this._element.nativeElement.disabled = _this.disableInput;
        }, 0);
    };
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DisableInputDirective.prototype, "disableInput", void 0);
    DisableInputDirective = __decorate([
        Directive({
            selector: '[disableInput]'
        }),
        __metadata("design:paramtypes", [ElementRef])
    ], DisableInputDirective);
    return DisableInputDirective;
}());
export { DisableInputDirective };
//# sourceMappingURL=disable-input.directive.js.map