import { ElementRef, OnDestroy, OnInit } from '@angular/core';
import { Observable } from 'rxjs';
export declare class LoadingDirective implements OnInit, OnDestroy {
    private _element;
    /**
     * Accepts list of Observable<boolean>.
     * Loading indicator will be shown if there is any Observable returns true value.
     */
    loading: Observable<boolean>[] | Observable<boolean>;
    private _loadingSubscription;
    private _show;
    constructor(_element: ElementRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    private _addLoadingIndicator;
    private _showLoadingIndicator;
}
