var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Pipe } from '@angular/core';
/*
 * Transform string type to custom format
 * Usage:
 *   value | stringTransform:format
 * Example:
 *   {{ 'text\ntext' | literalTextTransform }}
 *   formats to: text<br/>text
*/
var LiteralTextTransformPipe = /** @class */ (function () {
    function LiteralTextTransformPipe() {
    }
    LiteralTextTransformPipe.prototype.transform = function (value) {
        // invalid parameters
        if (!value) {
            return value;
        }
        return value.replace(/(\r?\n)/g, '<br/>');
    };
    LiteralTextTransformPipe = __decorate([
        Pipe({ name: 'literalTextTransform' })
    ], LiteralTextTransformPipe);
    return LiteralTextTransformPipe;
}());
export { LiteralTextTransformPipe };
//# sourceMappingURL=literal-text-transform.pipe.js.map