import { HttpErrorResponse } from '@angular/common/http';
import { NgRedux } from '@angular-redux/store';
import { IAppState } from '../stores';
export declare class ErrorActions {
    private _ngRedux;
    static SET_ERROR: string;
    constructor(_ngRedux: NgRedux<IAppState>);
    setErrorDispatch(stateKey: string, errorObject: any): void;
    setError(stateKey: string, errorObject: any): {
        type: string;
        payload: {
            stateKey: string;
            errorObject: any;
        };
    };
    extractError(error: HttpErrorResponse | any): any;
}
