export interface IPageEditsState {
    [systemId: string]: IPageEditState;
}
export interface IPageEditState {
    name: string;
    systemId: string;
    containers: IBlockContainer[];
    outOfSync: boolean;
    url: string;
    readable: boolean;
}
export interface IBlockContainer {
    name: string;
    id: string;
    blocks: IBlock[];
}
export interface IBlock {
    name: string;
    systemId: string;
    largeThumbnailUrl: any;
    sortOrder: number;
    properties: any;
    isGlobal: boolean;
    audienceConfigured: boolean;
    readable: boolean;
    writable: boolean;
}
