import { ComponentFactory, ViewContainerRef } from '@angular/core';
import { ExtendedFormGroup } from '../forms/extended-form-group';
/**
 * Generates components based on the JSON schema.
 */
export declare class ComponentCreatorService {
    generate(schema: any, defaultFormValues: any, placeHolder: ViewContainerRef, parentForm?: ExtendedFormGroup): Promise<ExtendedFormGroup[]>;
    fetchSchemaAsync(entityType: string, id: string, formData?: any): Promise<any>;
    getComponentFactory(name: string): Promise<ComponentFactory<any>>;
}
