import { ViewContainerRef } from '@angular/core';
import { BaseComponent } from '../base-component/base.component';
/**
 * Represents the base component for all container component.
 * It provides getter and setter for common attributes.
 */
export declare abstract class BaseContainer extends BaseComponent {
    name: string;
    ownerId: string;
    areaName: string;
    options: any[];
    contentContainer: ViewContainerRef;
}
