import { ElementRef, EventEmitter } from '@angular/core';
export declare class BaseDialog {
    close: Function;
    closeOnEscape: boolean;
    closeOnOutsideClick: boolean;
    submit: Function;
    submitOnEnter: boolean;
    cssClass: string;
    minWidth: number;
    minHeight: number;
    resizing: EventEmitter<{}>;
    resizeEnd: EventEmitter<{}>;
    style: Object;
    _oldHeight: number;
    _oldWidth: number;
    _focusableElement: ElementRef;
    preventClosing(event: MouseEvent): void;
    focus(): void;
    onResizing(event: any): void;
    onResizeEnd(event: any): void;
}
