import { ElementRef, EventEmitter } from '@angular/core';
import { Observable } from 'rxjs';
import { BaseComponent } from '../base-component/base.component';
import { ImageLazyLoadDirective, LazyLoadDirective } from '../../directives';
export declare class CardView extends BaseComponent {
    multiSelect: boolean;
    loading: Observable<boolean>;
    loadNextPage: Function;
    totalCount: number;
    items: any[];
    itemsPerPage: number;
    imageProp: string;
    nameProp: string;
    itemIdKey: string;
    iconClassProp: string;
    dragEnabled: boolean;
    rowReorderEnabled: boolean;
    expandThumbnail: boolean;
    itemHeight: number;
    itemWidth: number;
    onSortOrderChanged: EventEmitter<{}>;
    itemDoubleClick: EventEmitter<{}>;
    selectedChanged: EventEmitter<{}>;
    onDragStart: EventEmitter<{}>;
    onDragEnd: EventEmitter<{}>;
    selectedIds: string[];
    lastIndex: number;
    lazyLoadDirective: LazyLoadDirective;
    imageLazyLoadDirective: ImageLazyLoadDirective;
    container: ElementRef;
    reset(): void;
    deselect(): void;
    fullHeight(): void;
    startIndex: number;
    select(id: string, ctrlKey: boolean, shiftKey: boolean, index: number): void;
    _selectItemsBetween(startIndex: number, endIndex: number): void;
    onDndOrderSuccess(): void;
    ensureImageLoad(): void;
}
