import { EventEmitter, OnInit } from '@angular/core';
import { NgRedux } from '@angular-redux/store';
import { BaseComponent } from '../base-component/base.component';
import { IAppState } from '../../redux/stores';
import { FieldActions } from '../../redux/actions';
/**
 * Represents the field selector component.
 */
export declare class FieldSelector extends BaseComponent implements OnInit {
    private _ngRedux;
    private _fieldActions;
    visibleIds: Array<string>;
    areaName: string;
    value: any[];
    idSelector: (field: any) => any;
    textSelector: (field: any) => any;
    stateSelector: (state: IAppState) => any[];
    manualFetch: boolean;
    onFieldSelect: EventEmitter<{}>;
    private _fields;
    constructor(_ngRedux: NgRedux<IAppState>, _fieldActions: FieldActions);
    ngOnInit(): void;
    isChecked: (field: any) => boolean;
    _idSelector: (field: any) => any;
    _textSelector: (field: any) => any;
    readonly fields: any[];
}
