var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input } from '@angular/core';
import { NgRedux } from '@angular-redux/store';
var LanguageSelector = /** @class */ (function () {
    function LanguageSelector(_ngRedux) {
        this._ngRedux = _ngRedux;
    }
    LanguageSelector.prototype.ngOnInit = function () {
        this.languages$ = this._ngRedux.select(function (state) { return state.locale.languages; });
    };
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], LanguageSelector.prototype, "value", void 0);
    LanguageSelector = __decorate([
        Component({
            selector: 'language-selector',
            template: "\n      <select>\n          <option *ngFor=\"let opt of languages$ | async\" [value]=\"opt.id\" [selected]=\"opt.id == value\">{{ opt.title }}</option>\n      </select>\n    ",
        }),
        __metadata("design:paramtypes", [NgRedux])
    ], LanguageSelector);
    return LanguageSelector;
}());
export { LanguageSelector };
//# sourceMappingURL=language-selector.component.js.map