import { OnInit, EventEmitter, ElementRef } from '@angular/core';
export declare class Draggable implements OnInit {
    element: ElementRef;
    dragHandle: any;
    _isDraggable: boolean;
    _styleInitialized: boolean;
    mousedrag: any;
    mouseup: EventEmitter<{}>;
    mousedown: EventEmitter<{}>;
    mousemove: EventEmitter<{}>;
    onMouseup(event: any): void;
    onMousedown(event: any): void;
    onMousemove(event: any): void;
    constructor(element: ElementRef);
    ngOnInit(): void;
    private _setInitalStyle;
}
