import { ElementRef, OnDestroy, OnInit } from '@angular/core';
import { Observable } from 'rxjs';
export declare class ImageLazyLoadDirective implements OnInit, OnDestroy {
    private _element;
    loading: Observable<boolean>;
    private _onResizeSubscription;
    private _loadingSubscription;
    private _sourceAttributeName;
    constructor(_element: ElementRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    markForCheck(): void;
    private _onScroll;
    private _onElementScroll;
    private _isInViewport;
}
