var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Pipe } from '@angular/core';
/*
 * Filter list by name
 * Usage:
 *   value | filter:textSelectorFunction:filterText
 * or
 *   value | filter:textField:filterText
*/
var FilterPipe = /** @class */ (function () {
    function FilterPipe() {
    }
    FilterPipe.prototype.transform = function (items, field, value) {
        if (!field || !value) {
            return items;
        }
        if (typeof field === 'string') {
            return items.filter(function (item) { return item[field] && item[field].toLowerCase().indexOf(value.toLowerCase()) !== -1; });
        }
        return items.filter(function (item) { return field(item) && field(item).toLowerCase().indexOf(value.toLowerCase()) !== -1; });
    };
    FilterPipe = __decorate([
        Pipe({
            name: 'filter',
        })
    ], FilterPipe);
    return FilterPipe;
}());
export { FilterPipe };
//# sourceMappingURL=filter.pipe.js.map