import { HttpClient } from '@angular/common/http';
import { NgRedux } from '@angular-redux/store';
import { IAppState } from '../../stores';
import { BaseEntityListActions } from '../base-entity-list.actions';
import { ErrorActions } from '../error.actions';
import { LoadingActions } from '../loading.actions';
export declare class FieldActions extends BaseEntityListActions {
    protected ngRedux: NgRedux<IAppState>;
    protected http: HttpClient;
    protected errorActions: ErrorActions;
    protected loadingActions: LoadingActions;
    constructor(ngRedux: NgRedux<IAppState>, http: HttpClient, errorActions: ErrorActions, loadingActions: LoadingActions);
    readonly reducerName: string;
}
