var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { NgRedux } from '@angular-redux/store';
import { BaseEntityListActions } from '../base-entity-list.actions';
import { ErrorActions } from '../error.actions';
import { LoadingActions } from '../loading.actions';
import { NAMED_BASE_ENTITY_LIST_KEYS_FIELD_LIST } from '../../stores/named.reducer';
var FieldActions = /** @class */ (function (_super) {
    __extends(FieldActions, _super);
    function FieldActions(ngRedux, http, errorActions, loadingActions) {
        var _this = _super.call(this, ngRedux, http, errorActions, loadingActions) || this;
        _this.ngRedux = ngRedux;
        _this.http = http;
        _this.errorActions = errorActions;
        _this.loadingActions = loadingActions;
        return _this;
    }
    Object.defineProperty(FieldActions.prototype, "reducerName", {
        get: function () {
            return NAMED_BASE_ENTITY_LIST_KEYS_FIELD_LIST;
        },
        enumerable: true,
        configurable: true
    });
    FieldActions = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [NgRedux,
            HttpClient,
            ErrorActions,
            LoadingActions])
    ], FieldActions);
    return FieldActions;
}(BaseEntityListActions));
export { FieldActions };
//# sourceMappingURL=field.actions.js.map