export interface IErrorState {
    addEntityLoadingSchema: IError;
    addEntitySubmit: IError;
    fetchFolderModelPage: IError;
    fetchTask: IError;
    submitFormField: IError;
    submitUserInfo: IError;
}
export interface IError {
    message: string;
    modelState: {
        key: string;
        value: string;
    };
    byId: {
        [id: string]: string[];
    };
}
