var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { EventEmitter, Injectable } from '@angular/core';
import * as i0 from "@angular/core";
import * as i1 from "../../../ui.module";
var ReducerRegistry = /** @class */ (function () {
    function ReducerRegistry() {
        this.onChange = new EventEmitter();
        this._reducers = {};
    }
    Object.defineProperty(ReducerRegistry.prototype, "reducers", {
        get: function () {
            return __assign({}, this._reducers);
        },
        enumerable: true,
        configurable: true
    });
    ReducerRegistry.prototype.register = function (reducer) {
        this._reducers = __assign({}, this._reducers, reducer);
        this.onChange.emit(this.reducers);
    };
    ReducerRegistry.ngInjectableDef = i0.defineInjectable({ factory: function ReducerRegistry_Factory() { return new i1.ReducerRegistry(); }, token: i1.ReducerRegistry, providedIn: "root" });
    ReducerRegistry = __decorate([
        Injectable({ providedIn: 'root' })
    ], ReducerRegistry);
    return ReducerRegistry;
}());
export { ReducerRegistry };
//# sourceMappingURL=reducer-registry.js.map