var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { DndModule } from 'ng2-dnd';
import { ResizableModule } from 'angular-resizable-element';
import { TranslateModule } from '@ngx-translate/core';
import { SharedActions } from './Scripts/shared-actions';
import { SharedComponents } from './Scripts/shared-components';
import { SharedDirectives } from './Scripts/shared-directives';
import { SharedPipes } from './Scripts/shared-pipes';
import { ReducerRegistry } from './Scripts/redux/stores/reducer-registry';
export { ReducerRegistry } from './Scripts/redux/stores/reducer-registry';
export * from './Scripts/redux/stores';
export { namedReducer, NAMED_ANY, NAMED_BASE_ENTITY_LIST_KEYS_FIELD_LIST, } from './Scripts/redux/stores/named.reducer';
export * from './Scripts/components';
export * from './Scripts/directives';
export * from './Scripts/forms';
export * from './Scripts/redux/actions';
export * from './Scripts/pipes';
export * from './Scripts/decorators';
export { RemoteEventHubService } from './Scripts/services/remote-event-hub.service';
export { QueueRunnerService } from './Scripts/services/queue-runner.service';
export { ComponentCreatorService } from './Scripts/services/component-creator.service';
var UiModule = /** @class */ (function () {
    function UiModule() {
    }
    UiModule_1 = UiModule;
    UiModule.forRoot = function () {
        return {
            ngModule: UiModule_1,
            providers: [
                SharedActions,
                ReducerRegistry,
            ]
        };
    };
    var UiModule_1;
    UiModule = UiModule_1 = __decorate([
        NgModule({
            imports: [
                CommonModule,
                DndModule,
                FormsModule,
                ReactiveFormsModule,
                ResizableModule,
                TranslateModule,
            ],
            declarations: [
                SharedComponents,
                SharedDirectives,
                SharedPipes,
            ],
            exports: [
                CommonModule,
                FormsModule,
                ReactiveFormsModule,
                ResizableModule,
                SharedComponents,
                SharedDirectives,
                SharedPipes,
            ]
        })
    ], UiModule);
    return UiModule;
}());
export { UiModule };
//# sourceMappingURL=ui.module.js.map